//{$WARNINGS OFF}
//{$WARN SYMBOL_PLATFORM OFF}
//{$WARN UNIT_PLATFORM OFF}
//=============================================================================
//  ړTCYRg[֌WTv
//  摜`pNX̃eXg
//
//-----------------------------------------------------------------------------
//
//  ygpz
//
//  TCg̃AvP[VށCR|[lgCR[hނ́C]ځCρCzz
//  (IWiCϔ)Ȃǂ͑SĎRłDppRłDACgp̋L
//  ڋ`܂DIWî̂pƂ邱Ƃ͋֎~܂D
//  ȂC{TCg̃vOR[hgpƂɂĐCȂ
//  QCɊւĂ҂͈؊֗^Ȃ̂Ƃ܂DD
//
//-----------------------------------------------------------------------------
//
//  yz
//
//  2017N0920 ` 
//
//-----------------------------------------------------------------------------
//
//  ymFz
//
//  Windows 7 U64(SP1) + Delphi XE(UP1) Pro
//
//  Presented by Mr.XRAY
//  http://mrxray.on.coocan.jp/
//=============================================================================
unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtDlgs, plContainerPanel, ExtCtrls, plGPResizeImage,
  GDIPOBJ, GDIPAPI, GDIPUTIL;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    Button1: TButton;
    OpenPictureDialog1: TOpenPictureDialog;
    Button2: TButton;
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
  private
    { Private 錾 }
    FBackCtrl      : TplContainerPanel;
    FResizeImage   : TplGPResizeImage;
    FLoadInitDir   : string;
    FImageFilePath : string;
  public
    { Public 錾 }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

//=============================================================================
//  tH[̏
//=============================================================================
procedure TForm1.FormCreate(Sender: TObject);
begin
  Panel1.Caption := '';
  FLoadInitDir := ExpandFileName('..\..\Images');

  //wip̃Rg[
  FBackCtrl := TplContainerPanel.Create(Self);
  FBackCtrl.Parent    := Self;
  FBackCtrl.Align     := alClient;
  FBackCtrl.BackImage := True;
end;

//=============================================================================
//  摜t@Cǂݍŕ\
//=============================================================================
procedure TForm1.Button1Click(Sender: TObject);
begin
  OpenPictureDialog1.Filter     := '摜t@C|*.bmp;*.png;*.jpg;*.gif';
  OpenPictureDialog1.InitialDir := FLoadInitDir;
  if not OpenPictureDialog1.Execute then exit;

  FImageFilePath := OpenPictureDialog1.FileName;
  FLoadInitDir   := ExtractFileDir(FImageFilePath);


  //\̕`Rg[͑Sč폜
  FBackCtrl.DeleteAllCtrls;

  //VKɕ`Rg[𐶐
  FResizeImage := TplGPResizeImage.Create(Self);
  FResizeImage.Parent      := FBackCtrl;
  FResizeImage.InverseDisp := True;
  FResizeImage.LoadFromFile(FImageFilePath);
end;

//=============================================================================
//  \̉摜̈ꕔ擾ĕʂ̕`Rg[ŕ\
//=============================================================================
procedure TForm1.Button2Click(Sender: TObject);
var
  LCtrl        : TplGPResizeImage;
  LCtrlWidth   : Integer;
  LCtrlHeight  : Integer;
  LCopyRect    : TRect;
  LDstWidth    : Integer;
  LDstHeight   : Integer;
  LSrcGPBitmap : TGPBitmap;
  LDstGPBitmap : TGPBitmap;
  LGPGraphics  : TGPGraphics;
  LGPImageAttr : TGPImageAttributes;
begin
  try
  //`撆̕`Rg[擾
  //ŏ̉摜𑀍ΏۂƂ
    LCtrl := TplGPResizeImage(FBackCtrl.CtrlList[0]);

    //\(]Ԃ܂߂)̉摜TCYŐVKTGPBitmap쐬
    LCtrlWidth   := LCtrl.Width;
    LCtrlHeight  := LCtrl.Height;
    LSrcGPBitmap := TGPBitmap.Create(LCtrlWidth, LCtrlHeight);

    //Rs[͈͂ݒ
    LCopyRect := Bounds(20, 20, LCtrlWidth div 2, LCtrlHeight div 2);

    //Rs[摜i[TGPBitmap쐬
    LDstWidth    := LCopyRect.Right - LCopyRect.Left;
    LDstHeight   := LCopyRect.Bottom - LCopyRect.Top;
    LDstGPBitmap := TGPBitmap.Create(LDstWidth, LDstHeight);

    //LSrcGPBitmapɕ\̉摜`
    LCtrl.DrawRoutine(nil, LSrcGPBitmap);


    //Rs[TGPBitmapɌ̉摜̎w͈͂`
    LGPGraphics := TGPGraphics.Create(LDstGPBitmap);

    //A`GCAX̐ݒ
    LGPImageAttr := TGPImageAttributes.Create;
    LGPImageAttr.SetWrapMode(WrapModeTileFlipXY);
    LGPGraphics.SetPixelOffsetMode(PixelOffsetModeHalf);

    LGPGraphics.DrawImage(LSrcGPBitmap,
                          MakeRect(0, 0, LDstWidth, LDstHeight),
                          LCopyRect.Left,
                          LCopyRect.Top,
                          LCopyRect.Right  - LCopyRect.Left,
                          LCopyRect.Bottom - LCopyRect.Top,
                          UnitPixel,
                          LGPImageAttr);


    //Rs[摜`Rg[VKɍ쐬Ăɕ`
    FResizeImage := TplGPResizeImage.Create(Self);
    FResizeImage.Parent      := FBackCtrl;
    FResizeImage.InverseDisp := True;
    FResizeImage.GPBitmap := LDstGPBitmap;
  finally
    FreeAndNil(LSrcGPBitmap);
    FreeAndNil(LDstGPBitmap);
    FreeAndNil(LGPGraphics);
    FreeAndNil(LGPImageAttr);
  end;
end;

end.
