//{$WARNINGS OFF}
//{$WARN SYMBOL_PLATFORM OFF}
//{$WARN UNIT_PLATFORM OFF}
//=============================================================================
//  ړTCYRg[֌WTv
//  摜`pNX̃eXg
//
//-----------------------------------------------------------------------------
//
//  ygpz
//
//  TCg̃AvP[VށCR|[lgCR[hނ́C]ځCρCzz
//  (IWiCϔ)Ȃǂ͑SĎRłDppRłDACgp̋L
//  ڋ`܂DIWî̂pƂ邱Ƃ͋֎~܂D
//  ȂC{TCg̃vOR[hgpƂɂĐCȂ
//  QCɊւĂ҂͈؊֗^Ȃ̂Ƃ܂DD
//
//-----------------------------------------------------------------------------
//
//  yz
//
//  2017N0920 ` 
//
//-----------------------------------------------------------------------------
//
//  ymFz
//
//  Windows 7 U64(SP1) + Delphi XE(UP1) Pro
//
//  Presented by Mr.XRAY
//  http://mrxray.on.coocan.jp/
//=============================================================================
unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtDlgs, plContainerPanel, ExtCtrls, plGPResizeImage,
  GDIPOBJ, GDIPAPI, GDIPUTIL;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    Button1: TButton;
    OpenPictureDialog1: TOpenPictureDialog;
    Button2: TButton;
    ColorDialog1: TColorDialog;
    Panel2: TPanel;
    Image1: TImage;
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Image1Click(Sender: TObject);
  private
    { Private 錾 }
    FBackCtrl      : TplContainerPanel;
    FResizeImage   : TplGPResizeImage;
    FLoadInitDir   : string;
    FImageFilePath : string;
  public
    { Public 錾 }
    function ChangeColor(TarGPBitmap: TGPBitmap; OldColor, NewColor: TGPColor):
      Boolean;
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

//=============================================================================
//  tH[̏
//=============================================================================
procedure TForm1.FormCreate(Sender: TObject);
begin
  Panel1.Caption := '';
  FLoadInitDir := ExpandFileName('..\..\Images');

  //wip̃Rg[
  FBackCtrl := TplContainerPanel.Create(Self);
  FBackCtrl.Parent    := Self;
  FBackCtrl.Align     := alClient;
  FBackCtrl.BackImage := True;
end;

//=============================================================================
//  摜t@Cǂݍŕ\
//=============================================================================
procedure TForm1.Button1Click(Sender: TObject);
begin
  OpenPictureDialog1.Filter     := '摜t@C|*.bmp;*.png;*.jpg;*.gif';
  OpenPictureDialog1.InitialDir := FLoadInitDir;
  if not OpenPictureDialog1.Execute then exit;

  FImageFilePath := OpenPictureDialog1.FileName;
  FLoadInitDir   := ExtractFileDir(FImageFilePath);


  //\̕`Rg[͑Sč폜
  FBackCtrl.DeleteAllCtrls;

  //VKɕ`Rg[𐶐
  FResizeImage := TplGPResizeImage.Create(Self);
  FResizeImage.Parent      := FBackCtrl;
  FResizeImage.InverseDisp := True;
  FResizeImage.LoadFromFile(FImageFilePath);
end;

//=============================================================================
//  `Rg[ɕ`撆̉摜̃sNZ̐FύX
//
//  ݕ\̃TCY(]Ԃ܂߂)̉摜ɑ΂đ
//=============================================================================
procedure TForm1.Button2Click(Sender: TObject);
var
  LCtrl       : TplGPResizeImage;
  LCtrlWidth  : Integer;
  LCtrlHeight : Integer;
  LGPBitmap   : TGPBitmap;
  LGPColor    : TGPColor;
  LGPNewColor : TGPColor;
begin
  if FBackCtrl.CtrlList.Count = 0 then exit;

  if Sender = nil then begin
    LGPNewColor :=0;
  end else begin
    if not ColorDialog1.Execute then exit;
    LGPNewColor := ColorRefToARGB(ColorDialog1.Color);
  end;

  try
    //`Rg[̃CX^X擾
    LCtrl := TplGPResizeImage(FBackCtrl.CtrlList[0]);
    //̃Rg[ɕ`撆̃TCYŐVKTGPBitmap𐶐
    LCtrlWidth  := LCtrl.Width;
    LCtrlHeight := LCtrl.Height;
    LGPBitmap   := TGPBitmap.Create(LCtrlWidth, LCtrlHeight);

    //쐬TGPBitmapɌݕ\̉摜`
    LCtrl.DrawRoutine(nil, LGPBitmap);

    //摜̍̃sNZ̐F擾
    LGPBitmap.GetPixel(0, LGPBitmap.GetHeight - 1, LGPColor);
    //̐FƓF̃sNZʂ̐FɕύX
    ChangeColor(LGPBitmap, LGPColor, LGPNewColor);

    //ҏWTGPBitmap`Rg[̐V摜Ƃ
    LCtrl.GPBitmap := LGPBitmap;
  finally
    FreeAndNil(LGPBitmap);
  end;
end;

//=============================================================================
//  Image1OnClickCxg
//  FɕύX
//=============================================================================
procedure TForm1.Image1Click(Sender: TObject);
begin
  Button2Click(nil);
end;

//-----------------------------------------------------------------------------
//  w肵F̃sNZʂ̐FɕύX֐
//
//  GDI+ɂTColorMapŐFύXł邪TColorMap̓J[}bv̕ύXȂ̂
//  ʏł͎w肵FłȂsNZ̐FύXꍇ
//-----------------------------------------------------------------------------
function TForm1.ChangeColor(TarGPBitmap: TGPBitmap; OldColor,
  NewColor: TGPColor): Boolean;
var
  LImgWidth   : Integer;
  LImgHeight  : Integer;
  LBmpData    : TBitmapData;
  LScanLine   : PByte;
  LpRGBQuad   : PRGBQuad;
  LDataStride : Integer;
  LXPos       : integer;
  LYPos       : Integer;
  LAValue     : Byte;
  LRValue     : Byte;
  LGValue     : Byte;
  LBValue     : Byte;
  LOldColor   : TGPColor;
begin
  Result := False;

  LImgWidth  := TarGPBitmap.GetWidth;
  LImgHeight := TarGPBitmap.GetHeight;

  //TGPBitmap̃rbg}bvf[^擾
  if TarGPBitmap.LockBits(MakeRect(0, 0, LImgWidth, LImgHeight), ImageLockModeWrite,
                                 PixelFormat32bppARGB, LBmpData) <> Ok then exit;

  LScanLine   := LBmpData.Scan0;
  LDataStride := LBmpData.Stride;

  for LYPos := 0 to LImgHeight - 1 do begin
    LpRGBQuad  := PRGBQuad(LScanLine);

    for LXPos := 0 to LImgWidth - 1 do begin

      LAValue   := LpRGBQuad^.rgbReserved;
      LRValue   := LpRGBQuad^.rgbRed;
      LGValue   := LpRGBQuad^.rgbGreen;
      LBValue   := LpRGBQuad^.rgbBlue;
      LOldColor := MakeColor(LAValue, LRValue, LGValue, LBValue);

      if LOldColor = OldColor then begin
        LpRGBQuad^.rgbReserved := GetAlpha(NewColor);
        LpRGBQuad^.rgbRed      := GetRed(NewColor);
        LpRGBQuad^.rgbGreen    := GetGreen(NewColor);
        LpRGBQuad^.rgbBlue     := GetBlue(NewColor);
      end;
      Inc(LpRGBQuad);
    end;
    Inc(LScanLine, LDataStride);
  end;

  TarGPBitmap.UnlockBits(LBmpData);
  Result := True;
end;

end.
